#delimit;

* adapted to STATA from ssupbld5.sas;
* computes the two definitions of taxable income;
* taxct = constant def close to 1990 definition in real terms;
* taxlm = locally moving definition of taxable income;
* pce variable produced by fortran programs;
* now totitm replaces totald

* cd c:\manu\papers\taxref\statend\build;


clear;
set memory 300000;


/*

use d:\data\irs\tall.dta;
keep if id/50-int(id/50)==0;
save d:\data\irs\subset.dta;
clear;
*/

/*
use d:\data\irs\subset.dta;
for var agex-e90_110: replace X=0 if X==.;
sort flpdyr id;
* save d:\scratch\tall.dta, replace;
gen refpce=0.929; * this is the pce for year 90;
* ttladj already defined for years 79,80,81;
replace ttladj=moving+empexp+iraded+keogh+penlty+almpd+secern
if flpdyr==84 | flpdyr==85 | flpdyr==86;
replace ttladj=empexp+iraded+irasec+keogh+penlty+almpd
if flpdyr==87;
replace ttladj=empexp+iraded+irasec+keogh+penlty+almpd+health
if flpdyr>=88;
replace ttladj=hsetax+empexp+iraded+irasec+keogh+penlty+almpd+health
if flpdyr==90;

gen broad=0;
replace broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi
if flpdyr<=80 | flpdyr==82 | flpdyr==83;
replace broad=agi+ttladj+divrec+inty-divint+1.5*(cgdist+cgagi)+ui-uiagi
if flpdyr==81;
replace broad=agi+ttladj+divrec-divagi+1.5*(cgdist+cgagi)+ui-uiagi-ssagi
if flpdyr==84 | flpdyr==85 | flpdyr==86;
replace broad=agi+ttladj-ssagi
if flpdyr>=87;

gen broadn=broad-(cgdist+cgagi);
replace broadn=broad-1.5*(cgdist+cgagi) if flpdyr<=86;

gen item=0;
replace item=1 if flpdyr<87 & itded!=0;
replace item=1 if flpdyr==87 & agex==0 &
 (totitm!=2540 & totitm!=3760 & totitm!=1880);
replace item=1 if flpdyr==87 & agex>0 &
 (totitm!=3750 & totitm!=4500 & totitm!=5600 & totitm!=6200
& totitm!=6800 & totitm!=7400 & totitm!=5150 & totitm!=5900);
replace item=1 if flpdyr==88 & agex==0 &
 (totitm!=3000 & totitm!=5000 & totitm!=2500 & totitm!=4400);
replace item=1 if flpdyr==88 & agex>0 &
 (totitm!=3750 & totitm!=4500 & totitm!=5600 & totitm!=6200
& totitm!=6800 & totitm!=7400 & totitm!=5150 & totitm!=5900);
replace item=1 if flpdyr==89 & agex==0 &
 (totitm!=3100 & totitm!=5200 & totitm!=2600 & totitm!=4550);
replace item=1 if flpdyr==89 & agex>0 &
 (totitm!=3850 & totitm!=4600 & totitm!=5800 & totitm!=6400
& totitm!=7000 & totitm!=7600 & totitm!=5300 & totitm!=6050);
replace item=1 if flpdyr==90 & agex==0 &
 (totitm!=3250 & totitm!=5450 & totitm!=2725 & totitm!=4750);
replace item=1 if flpdyr==90 & agex>0 &
 (totitm!=4050 & totitm!=4850 & totitm!=6100 & totitm!=6750
& totitm!=7400 & totitm!=8050 & totitm!=5550 & totitm!=6350);

gen stdded=0;
replace stdded=2300 if flpdyr<=84 & (mars==1 | mars==4);
replace stdded=3400 if flpdyr<=84 & (mars==2 | mars==5);
replace stdded=1700 if flpdyr<=84 & (mars==3 | mars==6);
replace stdded=2390 if flpdyr==85 & (mars==1 | mars==4);
replace stdded=3540 if flpdyr==85 & (mars==2 | mars==5);
replace stdded=1770 if flpdyr==85 & (mars==3 | mars==6);
replace stdded=2480 if flpdyr==86 & (mars==1 | mars==4);
replace stdded=3670 if flpdyr==86 & (mars==2 | mars==5);
replace stdded=1835 if flpdyr==86 & (mars==3 | mars==6);
replace stdded=2540 if flpdyr==87 & (mars==1 | mars==4);
replace stdded=3760 if flpdyr==87 & (mars==2 | mars==5);
replace stdded=1880 if flpdyr==87 & (mars==3 | mars==6);
replace stdded=3000 if flpdyr==88 & (mars==1);
replace stdded=4400 if flpdyr==88 & (mars==4);
replace stdded=5000 if flpdyr==88 & (mars==2 | mars==5);
replace stdded=2500 if flpdyr==88 & (mars==3 | mars==6);
replace stdded=5100 if flpdyr==89 & (mars==1);
replace stdded=6550 if flpdyr==89 & (mars==4);
replace stdded=9200 if flpdyr==89 & (mars==2);
replace stdded=7200 if flpdyr==89 & (mars==5);
replace stdded=2000 if flpdyr==89 & (mars==3 | mars==6);
replace stdded=5300 if flpdyr==90 & (mars==1);
replace stdded=6800 if flpdyr==90 & (mars==4);
replace stdded=9550 if flpdyr==90 & (mars==2);
replace stdded=7500 if flpdyr==90 & (mars==5);
replace stdded=2050 if flpdyr==90 & (mars==3 | mars==6);

* standard deduction in 1990;
gen refded=0;
replace refded=5300 if (mars==1);
replace refded=6800 if (mars==4);
replace refded=9550 if (mars==2);
replace refded=7500 if (mars==5);
replace refded=2050 if (mars==3 | mars==6);

* age & blindness exemptions using 1990 tax year;
replace refded=refded+650*(xtot-xother) if flpdyr<=86
& (mars==2 | mars==3 | mars==5 | mars==6);
replace  refded=refded+800*(xtot-xother) if flpdyr<=86
& (mars==1 | mars==4);
replace refded=refded+650*max(agexb,agex) if flpdyr>=87
& (mars==2 | mars==3 | mars==5 | mars==6);
replace refded=refded+800*max(agexb,agex) if flpdyr>=87  & (mars==1 | mars==4);


gen taxct=0; * TAXABLE INCOME CONSTANT DEF;

save d:\scratch\tall.dta, replace;


for A in num 1/3:

clear \
infile flpdyr id taxf0 taxs0 wratef0 wrates0 taxf1 taxs1
wratef1 wrates1 pce taxlm0 taxlm1 taxln0 taxln1 using
"c:\manu\data\paneluse\taxsim\wagA.tab" \
keep if id/50-int(id/50)==0 \
replace flpdyr=flpdyr-1900 \
sort flpdyr id \
merge flpdyr id using "d:\scratch\tall.dta" \
sort flpdyr id \
sum _merge \ drop _merge \
save "d:\scratch\tallA.dta", replace \
clear \
infile flpdyr id taxf0b taxs0b ratef0 rates0 taxf1b taxs1b
ratef1 rates1 pceb taxlm0b taxlm1b taxln0b taxln1b using
"c:\manu\data\paneluse\taxsim\bro1.tab" \
keep if id/50-int(id/50)==0 \
replace flpdyr=flpdyr-1900 \
sort flpdyr id \
merge flpdyr id using "d:\scratch\tallA.dta" \
drop pceb taxf0b taxs0b taxf1b taxs1b taxlm0b taxlm1b taxln0b
taxln1b \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce-xother*2050-refded)/refpce
if flpdyr<=80 \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totitm*refpce/pce)/refpce
if flpdyr<=80 & item==1 & (totitm+nonit+moving)*refpce/pce>refded \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec+inty-divint+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce-xother*2050-refded)/refpce
if flpdyr==81 \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec+inty-divint+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totitm*refpce/pce)/refpce
if flpdyr==81 & item==1 & (totitm+nonit+moving)*refpce/pce>refded \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+nonit+moving-ssagi+iraded+keogh+irasec)/pce
-xother*2050-refded)/refpce if flpdyr>=82 & flpdyr<=86 \
replace taxct=(refpce*(agi-cgagi-cgdist+divrec-divagi+ui-uiagi+secern+saletx-ssagi+iraded+keogh+irasec)/pce-xother*2050-totitm*refpce/pce)/refpce
if flpdyr>=82 & flpdyr<=86 & item==1 &
(totitm+nonit+moving)*refpce/pce>refded \
replace taxct=(refpce*(agi-cgagi-cgdist-ssagi+iraded+keogh+irasec)/pce-xtot*2050-refded)/refpce
if flpdyr>=87 & flpdyr<=89  \
replace taxct=(refpce*(agi-cgagi-cgdist-ssagi+iraded+keogh+irasec)/pce-xtot*2050-totitm*refpce/pce)/refpce
if flpdyr>=87 & flpdyr<=89 & item==1 & totitm*refpce/pce>refded  \
replace taxct=(agi-cgagi-cgdist-ssagi+hsetax+iraded+keogh+irasec-xtot*2050-totitm)/refpce
if flpdyr==90 \

keep
taxf0 taxs0 taxf1 taxs1
ratef0 ratef1 rates0 rates1
wratef0 wratef1 wrates0 wrates1
taxlm0 taxlm1 taxln0 taxln1 pce
item stdded refded broadn refpce taxct broad
flpdyr id mars state  xtot xother
agi wages  cgagi cgdist ttladj
itded nonit exempt totitm agex agexb newtxy txst
party partl sbtly sbtlss esty estlss rentyl ryltyl
frent passl npassl smbloss sbnpls
partny smbpy smbnpy passy npassy \
save "d:\scratch\tallA.dta", replace;

*/

* 1 year lag;
for X in num 79/90: clear \ use "d:\scratch\tall1.dta" \ keep if flpdyr==X \
sort id \ save "d:\scratch\tallsX.dta", replace;
for X in num 80/90 \ Y in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \ for Z in var ratef0-taxct:
rename Z Z2 \ sort id \ save "d:\scratch\dtallY.dta", replace;
for X in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \
merge id using "d:\scratch\dtallX.dta" \
keep if _merge==3 \ drop _merge \
save "d:\scratch\dtallX.dta", replace;
clear; use "d:\scratch\dtall79.dta";
for X in num 80/89: append using "d:\scratch\dtallX.dta";
save "d:\scratch\d1tallex", replace;
for X in num 1/3: gen mrsX=0  \ replace mrsX=1 if mars==X;
gen broadr=broad/pce ;
gen broad2r=broad2/pce2 ;
gen lnbroad=log(broadr) ;
gen dlogb=log(broad2r/broadr) ;
gen incefp=log((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce)) ;
gen fincefp=log((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce)) ;
gen inceff=log((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce)) ;
gen finceff=log((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce)) ;
gen incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr ;
gen inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr ;
gen dmargp=log((100-ratef1-rates1)/(100-ratef0-rates0)) ;
gen dmargt=log((100-ratef02-rates02)/(100-ratef0-rates0)) ;
gen fdmargp=log((100-ratef1)/(100-ratef0)) ;
gen fdmargt=log((100-ratef02)/(100-ratef0)) ;
gen wdmargp=log((100-wratef1-wrates1)/(100-wratef0-wrates0)) ;
gen wdmargt=log((100-wratef02-wrates02)/(100-wratef0-wrates0)) ;
gen wfdmargp=log((100-wratef1)/(100-wratef0)) ;
gen wfdmargt=log((100-wratef02)/(100-wratef0)) ;
save "d:\scratch\d1tallex", replace;

* 2 year lag;
for X in num 79/90: clear \ use "d:\scratch\tall1.dta" \ keep if flpdyr==X \
sort id \ save "d:\scratch\tallsX.dta", replace;
for X in num 80/90 \ Y in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \ for Z in var ratef0-taxct:
rename Z Z2 \ sort id \ save "d:\scratch\dtallY.dta", replace;
for X in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \
merge id using "d:\scratch\dtallX.dta" \
keep if _merge==3 \ drop _merge \
save "d:\scratch\dtallX.dta", replace;
clear; use "d:\scratch\dtall79.dta";
for X in num 80/89: append using "d:\scratch\dtallX.dta";
save "d:\scratch\d1tallex", replace;
for X in num 1/3: gen mrsX=0  \ replace mrsX=1 if mars==X;
gen broadr=broad/pce ;
gen broad2r=broad2/pce2 ;
gen lnbroad=log(broadr) ;
gen dlogb=log(broad2r/broadr) ;
gen incefp=log((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce)) ;
gen fincefp=log((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce)) ;
gen inceff=log((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce)) ;
gen finceff=log((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce)) ;
gen incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr ;
gen inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr ;
gen dmargp=log((100-ratef1-rates1)/(100-ratef0-rates0)) ;
gen dmargt=log((100-ratef02-rates02)/(100-ratef0-rates0)) ;
gen fdmargp=log((100-ratef1)/(100-ratef0)) ;
gen fdmargt=log((100-ratef02)/(100-ratef0)) ;
gen wdmargp=log((100-wratef1-wrates1)/(100-wratef0-wrates0)) ;
gen wdmargt=log((100-wratef02-wrates02)/(100-wratef0-wrates0)) ;
gen wfdmargp=log((100-wratef1)/(100-wratef0)) ;
gen wfdmargt=log((100-wratef02)/(100-wratef0)) ;
save "d:\scratch\d1tallex", replace;

* 1 year lag;
for X in num 79/90: clear \ use "d:\scratch\tall1.dta" \ keep if flpdyr==X \
sort id \ save "d:\scratch\tallsX.dta", replace;
for X in num 80/90 \ Y in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \ for Z in var ratef0-taxct:
rename Z Z2 \ sort id \ save "d:\scratch\dtallY.dta", replace;
for X in num 79/89:
clear \ use "d:\scratch\tallsX.dta" \
merge id using "d:\scratch\dtallX.dta" \
keep if _merge==3 \ drop _merge \
save "d:\scratch\dtallX.dta", replace;
clear; use "d:\scratch\dtall79.dta";
for X in num 80/89: append using "d:\scratch\dtallX.dta";
save "d:\scratch\d1tallex", replace;
for X in num 1/3: gen mrsX=0  \ replace mrsX=1 if mars==X;
gen broadr=broad/pce ;
gen broad2r=broad2/pce2 ;
gen lnbroad=log(broadr) ;
gen dlogb=log(broad2r/broadr) ;
gen incefp=log((broadr-(taxf1+taxs1)/pce)/(broadr-(taxf0+taxs0)/pce)) ;
gen fincefp=log((broadr-(taxf1)/pce)/(broadr-(taxf0)/pce)) ;
gen inceff=log((broad2r-(taxf02+taxs02)/pce2)/(broadr-(taxf0+taxs0)/pce)) ;
gen finceff=log((broad2r-(taxf02)/pce2)/(broadr-(taxf0)/pce)) ;
gen incefp2=(-(taxf1+taxs1)/pce+(taxf0+taxs0)/pce)/broadr ;
gen inceff2=(broad2r-(taxf02+taxs02)/pce2-broadr+(taxf0+taxs0)/pce)/broadr ;
gen dmargp=log((100-ratef1-rates1)/(100-ratef0-rates0)) ;
gen dmargt=log((100-ratef02-rates02)/(100-ratef0-rates0)) ;
gen fdmargp=log((100-ratef1)/(100-ratef0)) ;
gen fdmargt=log((100-ratef02)/(100-ratef0)) ;
gen wdmargp=log((100-wratef1-wrates1)/(100-wratef0-wrates0)) ;
gen wdmargt=log((100-wratef02-wrates02)/(100-wratef0-wrates0)) ;
gen wfdmargp=log((100-wratef1)/(100-wratef0)) ;
gen wfdmargt=log((100-wratef02)/(100-wratef0)) ;
save "d:\scratch\d1tallex", replace;






/*




DATA bobo.d3fel;
set bobo.d3tall;
if flpdyr=85;
run;
